#!/usr/bin/env python3
#-*- mode: python; coding: utf-8 -*-

import os
try:
    from urllib import unquote
except ImportError:
    from urllib.parse import unquote

import gi
gi.require_version('GConf', '2.0')
gi.require_version('Nautilus', '3.0')
from gi.repository import Nautilus, GObject, GConf


class OpenDataManagerExtension(Nautilus.MenuProvider, GObject.GObject):
    def __init__(self):
        self.client = GConf.Client.get_default()
        
    def _open_dataManager(self, file, nautilus_window):
        path = unquote(file.get_uri()[7:])
        os.system("/usr/share/dataman/folderManager '%s'" % path)
        # Refresh
        action = nautilus_window.lookup_action("reload")
        action.emit("activate", None)
        
    def menu_activate_cb(self, menu, file, nautilus_window):
        self._open_dataManager(file, nautilus_window)
        
    def menu_background_activate_cb(self, menu, file, nautilus_window): 
        self._open_dataManager(file, nautilus_window)
       
    def get_file_items(self, window, files):
        if len(files) != 1:
            return
        
        file = files[0]
        if not file.is_directory() or file.get_uri_scheme() != 'file':
            return
       
        item = Nautilus.MenuItem(name='NautilusPython::opendatamanager_file_item',
                                 label='데이타맨 관리자' ,
                                 tip='Open DataManager In %s' % file.get_name())
        item.connect('activate', self.menu_activate_cb, file, window)
        return item,

    def get_background_items(self, window, file):
        item = Nautilus.MenuItem(name='NautilusPython::opendatamanager_file_item2',
                                 label='데이타맨 관리자' ,
                                 tip='Open DataManager In %s' % file.get_name())
        item.connect('activate', self.menu_background_activate_cb, file, window)
        return item,
